{% extends 'base.html.twig' %}

{% block stylesheets %}
    {{ parent() }}
    <link rel="stylesheet" href="{{ asset('scss/pages/tv.scss') }}">
    <link rel="stylesheet" href="https://unpkg.com/swiper/swiper-bundle.css">
    <link rel="stylesheet" href="https://unpkg.com/swiper/swiper-bundle.min.css">
    <link rel="stylesheet" href="{{ asset('gauge/style.css') }}">
{% endblock %}

{% block body %}
    {% include 'components/header.html.twig' %}
    {% include 'components/nav.html.twig' %}
    <div class="container-fluid">
    {% if detail is defined %}
        <div class="row container-title d-flex align-items-center justify-content-center" style="background: url('{{ detail.backdrop_path|displayTmdbImage() }}') no-repeat">
                <div class="filter"></div>
                <h2>{{ detail.original_title }} ({{ detail.release_date|date('Y') }})</h2>
                <h3>{{ detail.tagline }}</h3>
            </div>
            <div class="row description d-flex align-self-end justify-content-center align-items-center">
                <div class="col-sm-12 col-md-4 d-flex align-items-center justify-content-center">
                    {% for company in detail.production_companies %}
                        {{ company.name }}
                        {% if not loop.last %} | {% endif %}
                    {% endfor %}
                </div>
                <div class="col-sm-12 col-md-4 d-flex align-items-center justify-content-center">
                    {% for genre in detail.genres %}
                        {{ genre.name }}
                        {% if not loop.last %} | {% endif %}
                    {% endfor %}
                </div>
                <div class="col-sm-12 col-md-4 d-flex align-items-center justify-content-center">
                    <span class="fas fa-star mr-3 follow-link {% if detail.fav is defined %} favorite {% endif %}" data-id="{{detail.id}}"
                        data-toggle="tooltip" 
                        data-original-title="Favori"></span>
                </div>
            </div>
            <div class="row d-flex align-self-end justify-content-center align-items-center mt-3">
                <div class="col-sm-12 col-md-7 offset-1 d-flex align-items-center justify-content-center">
                    <img src="{{ (detail.poster_path|displayTmdbImage('w300')) }}">
                    <div class="wrapper-info ml-3">
                        <p>{{ detail.overview}}</p>
                        <p>Budget : {{ detail.budget == '0' ? 'Non renseigné' : detail.budget ~ ' $' }}</p>
                        <p>Date de réalisation : {{ detail.release_date }}</p>
                    </div>
                </div>
                <div class="col-sm-12 col-md-4 p-3 d-flex align-items-center justify-content-center flex-column">
                    {% include 'components/_gauge.html.twig' %}
                    <h4 class="mt-3">{{ detail.vote_count }} votes</h4>
                </div>
                <h3>Bandes annonces</h3>
                <div class="col-sm-12 col-md-12 p-3">
                    {% if videos.results %}
                        <div class="row d-flex align-items-center justify-content-between">
                                {% for video in videos.results %}
                                        <iframe class="mb-2 mt-2 col-sm-12 col-md-4 border-0" width="426" height="240"
                                                allowfullscreen="allowfullscreen"
                                                mozallowfullscreen="mozallowfullscreen"
                                                msallowfullscreen="msallowfullscreen"
                                                oallowfullscreen="oallowfullscreen"
                                                webkitallowfullscreen="webkitallowfullscreen"
                                                src="https://www.youtube.com/embed/{{ video.key }}">
                                        </iframe>
                                {% endfor %}
                        </div>
                    {% else %}
                        <div class="d-flex justify-content-center mt-5">
                            <h6 class="error-msg">Aucune bande annonce disponible.</h6>
                        </div>
                    {% endif %}
                </div>
            </div>
            <div class="row d-flex align-self-end justify-content-center align-items-center mt-5 mx-4">
                <h3 class="mb-5">Acteurs</h3>
                <!-- Slider main container -->
                <div class="swiper-container slider-cast mx-5">
                    <!-- Additional required wrapper -->
                    <div class="swiper-wrapper">
                        <!-- Slides -->
                        {% for cast in credits.cast %}
                            <div class="swiper-slide">
                                <img src="{{ (cast.profile_path|displayTmdbImage('w300', 'person')) }}">
                                <div class="d-flex flex-column align-items-center justify-content-center">
                                    <p class="mb-1">{{ cast.name }}</p>
                                    <p class="mb-1">({{ cast.character }})</p>
                                </div>
                            </div>
                        {% endfor %}
                    </div>
                    <!-- If we need navigation buttons -->
                    <div class="swiper-button-prev"></div>
                    <div class="swiper-button-next"></div>
                </div>
            </div>
            <div class="row d-flex align-self-end justify-content-center align-items-center mx-4">
                <h3 class="mb-5">Équipe</h3>
                <!-- Slider main container -->
                <div class="swiper-container slider-crew mx-5">
                    <!-- Additional required wrapper -->
                    <div class="swiper-wrapper">
                        <!-- Slides -->
                        {% for crew in credits.crew %}
                            <div class="swiper-slide d-flex flex-column align-items-center">
                                <img src="{{ (crew.profile_path|displayTmdbImage('w300', 'person')) }}">
                                <div class="d-flex flex-column align-items-center justify-content-center">
                                    <p class="mb-1">{{ crew.name }}</p>
                                    <p class="mb-1">({{ crew.job }})</p>
                                </div>
                            </div>
                        {% endfor %}
                    </div>
                    <!-- If we need navigation buttons -->
                    <div class="swiper-button-prev"></div>
                    <div class="swiper-button-next"></div>
                </div>
            </div>
            <div class="row d-flex align-items-center justify-content-center mt-5">
                <h4>Films similaires</h4>
            </div>
            {% if movies %}
                <div class="row" id="row-films-list">
                    {{ include('components/movie-list.html.twig') }}
                </div>
            {% else %}
                <div class="d-flex justify-content-center my-5">
                    <h6 class="error-msg">Aucun film similaire.</h6>
                </div>
            {% endif %}
    {% endif %}
    </div>
{% endblock %}

{% block javascripts %}
    <script src="https://unpkg.com/swiper/swiper-bundle.js"></script>
    <script src="https://unpkg.com/swiper/swiper-bundle.min.js"></script>
    <script>
        jQuery(document).ready(()=>{

            $('[data-toggle="tooltip"]').tooltip();

            var cast = new Swiper('.slider-cast', {
                slidesPerView: 6,
                loop: true,
                spaceBetween: 20,
                centeredSlides: true,
                navigation: {
                    nextEl: '.swiper-button-next',
                    prevEl: '.swiper-button-prev',
                },
                breakpoints: {
                    // when window width is >= 320px
                    320: {
                        slidesPerView: 2,
                        spaceBetween: 20
                    },
                    // when window width is >= 480px
                    480: {
                        slidesPerView: 3,
                        spaceBetween: 30
                    },
                    // when window width is >= 640px
                    640: {
                        slidesPerView: 4,
                        spaceBetween: 40
                    },
                    1000: {
                        slidesPerView: 6,
                        spaceBetween: 40
                    }
                }
            });

            var crew = new Swiper('.slider-crew', {
                slidesPerView: 6,
                loop: true,
                spaceBetween: 20,
                centeredSlides: true,
                navigation: {
                    nextEl: '.swiper-button-next',
                    prevEl: '.swiper-button-prev',
                },
                breakpoints: {
                    // when window width is >= 320px
                    320: {
                        slidesPerView: 2,
                        spaceBetween: 20
                    },
                    // when window width is >= 480px
                    480: {
                        slidesPerView: 3,
                        spaceBetween: 30
                    },
                    // when window width is >= 640px
                    640: {
                        slidesPerView: 4,
                        spaceBetween: 40
                    },
                    1000: {
                        slidesPerView: 6,
                        spaceBetween: 40
                    }
                }
            });

            refreshGauge();

            function refreshGauge(){
                var secondGauge = document.querySelector('.container:nth-of-type(1) .progress');
                var secondTarget = parseInt(secondGauge.getAttribute('data-target'));

                //variables
                var gaugeR = parseInt(document.querySelectorAll('circle')[0].getAttribute('r'));
                var gaugeC = gaugeR * Math.PI * 2;
                var animationDuration = 1.5;

                //init svg circles
                var circles = document.querySelectorAll('circle');
                var gauges = document.querySelectorAll('.progress');
                TweenMax.set(circles, {
                    strokeDashoffset: gaugeC
                });

                TweenMax.set(gauges, {
                    attr: {
                        'stroke-dasharray': gaugeC + ' ' + gaugeC
                    }
                });

                //calculate the offset
                function calculateOffset(t, c) {

                    var target = c - (c * t) / 100;
                    return target;

                }

                //timeline
                var tl = new TimelineMax();

                //second gauge animation
                tl.to(secondGauge, animationDuration, {
                    strokeDashoffset: calculateOffset(secondTarget, gaugeC),
                    ease: Power3.easeInOut
                });
            }

            var self = '';
            $('.follow-link').click(function () {
                self = $(this);
                $(this).css("color") == "rgb(255, 255, 255)" ? saveFav($(this).data('id')) : removeFav($(this).data('id'));
            })

            function saveFav(param) {
                let customUrl = '{{ path('app_addFav', {'id': 'PARAM'}) }}';
                customUrl = customUrl.replace('PARAM', param);
                jQuery.ajax({
                    type: 'GET',
                    url: customUrl,
                    success: function (response) {
                        self.addClass('favorite');
                    },
                    error: function (response) {
                    }
                });
            }

            function removeFav(param) {
                let customUrl = '{{ path('app_removeFav', {'id': 'PARAM'}) }}';
                customUrl = customUrl.replace('PARAM', param);
                jQuery.ajax({
                    type: 'GET',
                    url: customUrl,
                    success: function (response) {
                        self.removeClass('favorite');
                    },
                    error: function (response) {
                    }
                });

            }
        });
    </script>
{% endblock %}